/* V850 SD Player */

#include <stdarg.h>
#include <string.h>
#include "integer.h"
#include "v850es.h"

#define USE_DMA3

#define	LD_WORD(ptr)		(WORD)(((WORD)*(volatile BYTE*)((ptr)+1)<<8)|(WORD)*(volatile BYTE*)(ptr))
#define	LD_DWORD(ptr)		(DWORD)(((DWORD)*(volatile BYTE*)((ptr)+3)<<24)|((DWORD)*(volatile BYTE*)((ptr)+2)<<16)|((WORD)*(volatile BYTE*)((ptr)+1)<<8)|*(volatile BYTE*)(ptr))


int _rcopy(unsigned long*, long);
extern unsigned long _S_romp;

#define  PLAY_UP     0x01
#define  PLAY_DOWN   0x02
#define  PLAY_STOP   0x04
#define  PLAY_END    0x10

#define uart_start(chr)	 UA0TX = chr

static BYTE Buff[512]; 

/* MMC/SD command (in SPI) */
#define CMD0	(0x40+0)	/* GO_IDLE_STATE */
#define CMD1	(0x40+1)	/* SEND_OP_COND */
#define CMD8	(0x40+8)	/* SEND_IF_COND */
#define CMD9	(0x40+9)	/* SEND_CSD */
#define CMD10	(0x40+10)	/* SEND_CID */
#define CMD12	(0x40+12)	/* STOP_TRANSMISSION */
#define CMD16	(0x40+16)	/* SET_BLOCKLEN */
#define CMD17	(0x40+17)	/* READ_SINGLE_BLOCK */
#define CMD18	(0x40+18)	/* READ_MULTIPLE_BLOCK */
#define CMD24	(0x40+24)	/* WRITE_BLOCK */
#define CMD25	(0x40+25)	/* WRITE_MULTIPLE_BLOCK */
#define CMD41	(0x40+41)	/* SEND_OP_COND (ACMD) */
#define CMD55	(0x40+55)	/* APP_CMD */
#define CMD58	(0x40+58)	/* READ_OCR */

#define	ACMD41	(0xC0+41)	/* SEND_OP_COND (SDC) */

#define SELECT()	P9L.0 = 0	/* MMC CS = L */
#define	DESELECT()	P9L.0 = 1	/* MMC CS = H */

#define SOCKPORT	P9L			/* Socket contact port */
#define SOCKWP		0x04		/* Write protect switch (bit2) */
#define SOCKINS		0x02		/* Card detect switch (bit1) */

#define xmit_spi(dat) 	CB1TXL=(dat); do; while(CB1TSF)
#define rcvr_spi_m(dst)	CB1TXL=0xFF; do; while(CB1TSF); *(dst)=CB1RXL

/* VS1053 control signals */
#define DREQ	P9H.5
#define XCS		P9L.5
#define XDCS	P9L.4
#define XRESET	P9L.3

#define PUT_CB3(val) CB3TXL=(val); do;while(CB3TSF)

/* VS1053 SCI Write Command byte is 0x02 */
#define VS_WRITE_COMMAND 0x02

/* VS1053 SCI Read Command byte is 0x03 */
#define VS_READ_COMMAND 0x03

#define SPI_MODE	    0x0
#define SPI_STATUS	    0x1
#define SPI_BASS	    0x2
#define SPI_CLOCKF	    0x3
#define SPI_DECODE_TIME	0x4
#define SPI_AUDATA	    0x5
#define SPI_WRAM	    0x6
#define SPI_WRAMADDR	0x7
#define SPI_HDAT0	    0x8
#define SPI_HDAT1	    0x9
#define SPI_AIADDR	    0xa
#define SPI_VOL		    0xb
#define SPI_AICTRL0	    0xc
#define SPI_AICTRL1	    0xd
#define SPI_AICTRL2	    0xe
#define SPI_AICTRL3	    0xf

#define SM_DIFF		    0x01
#define SM_JUMP		    0x02
#define SM_RESET	    0x04
#define SM_OUTOFWAV	    0x08
#define SM_PDOWN	    0x10
#define SM_TESTS	    0x20
#define SM_STREAM	    0x40
#define SM_PLUSV	    0x80
#define SM_DACT		    0x100
#define SM_SDIORD	    0x200
#define SM_SDISHARE	    0x400
#define SM_SDINEW	    0x800
#define SM_ADPCM        0x1000
#define SM_ADPCM_HP     0x2000


volatile unsigned int  Timer1;
volatile unsigned char err;

volatile unsigned long BPB_sector;
volatile unsigned int  bytes_per_sector;
volatile unsigned char sectors_per_clustor;
volatile unsigned int  reserved_sectors;
volatile unsigned int  root_entry;
volatile unsigned long sectors_per_FAT;
volatile unsigned long root_directory;
volatile unsigned char root_entry_sectors;
volatile unsigned long data_area_start;
volatile unsigned int  next_file_no;
volatile unsigned long lba;
volatile unsigned char file_find;
volatile unsigned char file_no_search;
volatile unsigned int  max_file_no;
volatile unsigned int  next_file_no;
volatile unsigned char next_file_direct;
volatile unsigned int  fd_next_clustor;
volatile unsigned long fd_next_sector;
volatile unsigned long file_size_byte0;
volatile unsigned int  file_size_sector;

volatile unsigned char buf_rd;
volatile unsigned char buf_wr;
volatile unsigned int  ofs_r;
volatile unsigned int  remain;

volatile unsigned char Card_type;
volatile unsigned char FAT_type; /* 0: FAT16 1: FAT32 */

void LoadPatch(void);
void Delay(int milliseconds);
BYTE rcvr_spi(void);
BYTE wait_ready(void);
BYTE send_cmd(BYTE cmd, DWORD arg);
BYTE rcvr_datablock(BYTE *buff, UINT count);
BYTE MMC_Read(BYTE *buff, DWORD sector, BYTE count);
BYTE MMC_CardInit(void);
void xputc(char chr);
void xputs(char *str);
void xitoa(long val, char radix, char len);
void xprintf(char* str, ...);
void put_dump(BYTE *buff, DWORD ofs, int cnt);
void init(void);
void read_dir(void);
void VS_WRITE(void);
BYTE audio_play(void);
void vsreg_write (UINT reg, WORD val);
void VsSineTest(void);
void VS_Init(void);


/*
MMC I/F

VCC     : CON3-1   +3.3V
WP      : CON1-3   A2  -> P92               input
INS#    : CON1-2   A1  -> P91               input
CS#     : CON1-1   A0  -> P90               output   init : H
DO      : CON1-8   A7  -> P97 -> SIB1       input
DI      : CON1-9   A8  -> P98 -> SOB1       output   init : H
SCLK    : CON1-10  A9  -> P99 -> SCKB1-     output   init : L

DSP I/F

VDD     : CON3-1   +3.3V
XRESET# : CON1-4   A3  -> P93               output   init : L
DREQ    : CON1-14  A13 -> P913              input
XDCS#   : CON1-5   A4  -> P94               output   init : H
XCS#    : CON1-6   A5  -> P95               output   init : H
SO      : CON1-11  A10 -> P910 -> SIB3      input
SI      : CON1-12  A11 -> P911 -> SOB3      output   init : H
SCLK    : CON1-13  A12 -> P912 -> SCKB3-    output   init : L

UART I/F

P30 -> TXDA0   output  init : H
P31 -> RXDA0   input

SW I/F

SW1#    : CON2-1   P70    START/STOP
SW2#    : CON2-2   P71    UP
SW3#    : CON2-3   P72    DOWN
*/


#define SKIP_PLUGIN_VARNAME
const unsigned short patch[] = {
#include "vs1053b-patches.plg"
};


void LoadPatch(void)
{
   int i = 0;
   unsigned short addr, n, val;

   while (i<sizeof(patch)/sizeof(patch[0]))
   {
      addr = patch[i++];
      n = patch[i++];
      if (n & 0x8000U)
      {  /* RLE run, replicate n samples */
         n &= 0x7FFF;
         val = patch[i++];
         while (n--)
         {
            vsreg_write(addr, val);
         }
      }
      else
      {  /* Copy run, copy n samples */
         while (n--)
         {
            val = patch[i++];
            vsreg_write(addr, val);
         }
      }
   }
   Delay(1);
   while (!DREQ)
      ;
}

void Delay(int milliseconds)
{
   Timer1 = milliseconds;
   do; while(Timer1);
}

BYTE rcvr_spi(void)
{
   CB1TXL = 0xFF;
   do; while (CB1TSF);
   return CB1RXL;
}

BYTE wait_ready(void)
{
   BYTE res;

   Timer1 = 500;   /* Wait for ready in timeout of 500ms */
   rcvr_spi();
   do
   {
      res = rcvr_spi();
   } while ((res != 0xFF) && Timer1);

   return res;
}


BYTE send_cmd(BYTE cmd, DWORD arg)
{
   BYTE n, res;

   if (wait_ready() != 0xFF)
   {
      puts(" wait timeout of 500ms \r\n\n");
      return 0xFF;
   }

   /* xprintf(" CMD: 0x%02X \r\n", cmd); */

   /* Send command packet */
   xmit_spi(cmd);                 /* Command */
   xmit_spi((BYTE)(arg >> 24));   /* Argument[31..24] */
   xmit_spi((BYTE)(arg >> 16));   /* Argument[23..16] */
   xmit_spi((BYTE)(arg >> 8));    /* Argument[15..8] */
   xmit_spi((BYTE)arg);           /* Argument[7..0] */
   n = 0;
   if (cmd == CMD0) n = 0x95;     /* CRC for CMD0(0) */
   if (cmd == CMD8) n = 0x87;     /* CRC for CMD8(0x1AA) */
   xmit_spi(n);

   /* Receive command response */
   if (cmd == CMD12) rcvr_spi();  /* Skip a stuff byte when stop reading */
   n = 10;                        /* Wait for a valid response in timeout of 10 attempts */
   do
   {
      res = rcvr_spi();
   } while ((res & 0x80) && --n);

   if (!n)
     puts(" rsponse timeout of 10 attempts \r\n\n");

   return res;   /* Return with the response value */
}

BYTE rcvr_datablock(BYTE *buff, UINT count)
{
   BYTE res;

   Timer1 = 100;
   do
   {
      /* Wait for data packet in timeout of 100ms */
      res = rcvr_spi();
   } while ((res == 0xff) && Timer1);

   if(res != 0xfe) return 0; /* If not valid data token, retutn with error */

#ifdef USE_DMA3          /* (Platform dependent in DMA mode) */
   PMC9H.0 = 0;         /* Initialize CSIB1 to R/O mode */
   CB1CTL0 = 0;
   CB1CTL0 = 0xA1;

   DDA3H = (((DWORD)buff >> 16) | 0x8000) & 0x83FF; /* Destination address (data buffer) */
   DDA3L = (WORD)buff;
   DSA3H = 0x03FF;      /* Source address (CB1RXL) */
   DSA3L = 0xFD14;
   DADC3 = 0x0080;      /* Src fixed, Dst increment */
   DBC3  = count-1;     /* DMA count */
   DTFR3 = 0x20;        /* Triggered by INTCB1R */
   DCHC3 = 0x01;        /* Enable DMA */
   res = CB1RXL;        /* Start DMA xfer */
   do; while (!TC3);    /* Wait for end of xfer */
   do; while (CB1TSF);

   CB1CTL0 = 0;         /* Re-initialize CSIB1 to R/W mode */
   CB1CTL0 = 0xE0;
   PMC9H.0 = 1;
#else
   do
   {
	  /* Receive the data block into buffer */
      rcvr_spi_m(buff++);
      rcvr_spi_m(buff++);
   } while (count -= 2);
#endif
   rcvr_spi();  /* Discard CRC */
   rcvr_spi();

   return 1; /* Return with success */
}

BYTE MMC_Read(BYTE *buff, DWORD sector, BYTE count)
{
   if (!(Card_type & 4))
      sector *= 512;   /* Convert to byte address if needed */

   SELECT();      /* CS = L */
   if(count == 1) /* Single block read */
   {
      /* READ_SINGLE_BLOCK */
      if((send_cmd(CMD17, sector) == 0) && rcvr_datablock(buff, 512))
         count = 0;
   }
   else
   {
      /* READ_MULTIPLE_BLOCK */
      if(send_cmd(CMD18, sector) == 0)
      {
         do
         {
            if(!rcvr_datablock(buff, 512))
               break;
            buff += 512;
         } while (--count);
         send_cmd(CMD12, 0); /* STOP_TRANSMISSION */
      }
   }

   DESELECT(); /* CS = H */
   rcvr_spi(); /* Idle (Release DO) */

   return count ? 1 : 0;
}

BYTE MMC_CardInit(void)
{
   BYTE  n, p, res, cmd;
   BYTE  f, ocr[4];
   BYTE  ocr_d;

   res = 0;

   /* Card status check */
   p = SOCKPORT;
   if (P9L.1)	 /* INS = H (Socket empty) */
   {
      xputs(" Card empty\r\n\n ");
      res = 1;

      return res;
   }
   else
   {
      xputs(" Card inserted\r\n\n ");
      if (P9L.2)   /* WP is H (write protected) */
      {
         xputs(" Write proected\r\n\n ");
      }
      else
      {
         xputs(" Write enabled\r\n\n ");
      }
   }

   /* Card initialize */

   /* 80 dummy clocks */

   for (n=0; n<10; n++)
      rcvr_spi();

   SELECT();   /* CS = L */
   f = 0;
   if (send_cmd(CMD0, 0) == 1)   /* Enter Idle state */
   {
      xputs(" Enter Idle state \r\n\n ");

      Timer1 = 1000;   /* Initialization timeout of 1000 msec */

      if (send_cmd(CMD8, 0x1AA) == 1)   /* SDC Ver2+ */
      {
         xputs(" SDC Ver2+ \r\n\n ");

         for (n = 0; n < 4; n++)
            ocr[n] = rcvr_spi();
         if (ocr[2] == 0x01 && ocr[3] == 0xAA)   /* The card can work at vdd range of 2.7-3.6V */
         {
            do
            {
               if (send_cmd(CMD55, 0) <= 1 && send_cmd(CMD41, 1UL << 30) == 0)
                  break;
            } while (Timer1);
            if (Timer1 && send_cmd(CMD58, 0) == 0)   /* Check CCS bit */
            {
               for (n = 0; n < 4; n++)
               {
                  ocr[n] = rcvr_spi();
                  ocr_d = ocr[n];
                  /* xprintf(" ocr : 0x%02X \r\n", ocr_d); */
               }
               Card_type = (ocr[0] & 0x40) ? 6 : 2;
            }
         }
      }
      else   /* SDC Ver1 or MMC */
      {
         xputs(" SDC Ver1 or MMC \r\n\n ");

         if (send_cmd(CMD55, 0) <= 1 && send_cmd(CMD41, 0) <= 1)  /* SDC? */
         {
            xputs(" SDC \r\n\n ");
            Card_type = 2;
         }
         do
         {
            if (!f && send_cmd(CMD1, 0) == 0)
            {
               xputs(" MMC \r\n\n ");
               Card_type = 1;
               break;
            }
            if ( f && send_cmd(CMD55, 0) <= 1 && send_cmd(CMD41, 0) == 0)
            {
               xputs(" SDC Ver1 \r\n\n ");
               Card_type = 2;
               break;
            }
         } while (Timer1);
         if (Timer1)
            f = 1;
      }
      if (f == 1 && send_cmd(CMD16, 512) != 0)	/* Select R/W block length */
         Card_type = 0;
   }

   DESELECT();   /* CS = H */
   rcvr_spi();   /* Idle (Release DO) */

   if (Card_type)   /* Initialization succeded */
   {
      xputs(" Initialization succeded \r\n\n ");
      xprintf(" Card_type : %02u \r\n", Card_type);
   }
   else   /* Initialization failed */
   {
      xputs(" Initialization failed \r\n\n ");

      res = 1;
   }

   return res;
}

void xputc(char chr)
{
   if(UA0TIF == 1)
   {
      UA0TIF = 0;   /* 荞݃tONA */
      UA0TX  = chr; /* UA0TXɓ]f[^ */
   }
   while(UA0TIF == 0)
      ;
}

void xputs(char* str)
{
   char d;

   d = *str++;
   uart_start(d);

   while ((d = *str) != 0)
   {
      if(UA0TIF == 1)
      {
         UA0TIF = 0;
         UA0TX  = d;
         str++;
      }
   }
}

void xitoa(long val, char radix, char len)
{
   BYTE c, r, sgn = 0, pad = ' ';
   BYTE s[20], i = 0;
   DWORD v;

   if (radix < 0)
   {
      radix = -radix;
      if (val < 0)
      {
         val = -val;
         sgn = '-';
      }
   }
   v = val;
   r = radix;
   if (len < 0)
   {
      len = -len;
      pad = '0';
   }
   if (len > 20) return;
   do
   {
      c = (BYTE)(v % r);
      if (c >= 10) c += 7;
      c += '0';
      s[i++] = c;
      v /= r;
   } while (v);
   if (sgn) s[i++] = sgn;
   while (i < len)
      s[i++] = pad;
   do
      xputc(s[--i]);
   while (i);
}

void xprintf(char* str, ...)
{
   va_list arp;
   char d, r, w, s, l;

   va_start(arp, str);

   while ((d = *str++) != 0)
   {
      if (d != '%')
      {
         xputc(d); continue;
      }
      d = *str++;
      w = 0;
      r = 0;
      s = 0;
      l = 0;
      if (d == '0')
      {
         d = *str++;
         s = 1;
      }
      while ((d >= '0')&&(d <= '9'))
      {
         w += w * 10 + (d - '0');
         d = *str++;
      }
      if (s) w = -w;
      if (d == 'l')
      {
         l = 1;
         d = *str++;
      }
      if (!d) break;
      if (d == 's')
      {
         xputs(va_arg(arp, char*));
         continue;
      }
      if (d == 'c')
      {
         xputc(va_arg(arp, char));
         continue;
      }
      if (d == 'u') r = 10;
      if (d == 'd') r = -10;
      if (d == 'X') r = 16;
      if (d == 'b') r = 2;
      if (!r) break;
      if (l)
      {
         xitoa((long)va_arg(arp, long), r, w);
      }
      else
      {
         if (r > 0)
            xitoa((unsigned long)va_arg(arp, short), r, w);
         else
            xitoa((long)va_arg(arp, short), r, w);
      }
   }
}

void put_dump(BYTE *buff, DWORD ofs, int cnt)
{
   BYTE n;

   xprintf("\r\n%08lX ", ofs);
   for(n = 0; n < cnt; n++)
      xprintf(" %02X", buff[n]);
   xputc(' ');
   for(n = 0; n < cnt; n++)
   {
      if ((buff[n] < 0x20)||(buff[n] >= 0x7F))
         xputc('.');
      else
         xputc(buff[n]);
   }
}

void init(void)
{
   /* Setup GPIO pins to initial state */
   PM0      = 0x83;   /* P0: -LLLLL-- */               /* Port 0 : output 2-6 -> all 0 output : not use */
   PM1      = 0xFC;   /* P1: ------LL */               /* Port 1 : output 0-1 -> all 0 output : not use */
   P3       = 0x0001; /* P3: ------LL LLLLLLIH */      /* Port 3 : input  1  output 0,2-9     : bit 0,1 UART */
   PM3      = 0xFC02;
   PM4      = 0xF8;   /* P4: -----LLL */               /* Port 4 : output 0-2 -> all 0 output : not use */
   PM5      = 0xC0;   /* P5: --LLLLLL */               /* Port 5 : output 0-5 -> all 0 output : not use */
   P7L      = 0x0F;
   PM7L     = 0x07;   /* P7L: LLLLLZZZ */              /* Port 7 : input  0-2  output 3-11    : bit 0-2 SW */
   PM7H     = 0xF0;   /* P7H: ----LLLL */
   PMCM     = 0xF0;   /* PCM: ----LLLL */              /* Port CM: output 0-3 -> all 0 output     : not use  */
   PCT      = 0x53;   /* PCT: -H-H--HH */              /* Port CT: output 0,1,4,6 -> all 1 output : bit6 LED */
   PMCT     = 0xAC;
   P9       = 0xEDF7; /* P9: ZZZLHZLH ZZHHLZZH */      /* Port 9 : input 1,2,6,7,10,13,14,15  output 0,3,4,5,8,9,11,12 : bit 7-12 CSIB */
   PM9      = 0xE4C6;
   PMDL     = 0x0000; /* PDL: LLLLLLLL LLLLLLLL */     /* Port DL: output 0-15 -> all 0 output : not use */
   PMDH     = 0xC0;   /* PDH: --LLLLLL */              /* Port DH: output 0-5  -> all 0 output : not use */

   /* Initialize MMC I/F */
   PMC9    |= 0x0380; /* Attach CSIB1 unit to I/O pad */
   PFC9    |= 0x0380;
   CB1CTL1  = 0x18;   /* Select fclk=fxx/2, SPI mode 0 */
   CB1CTL2  = 0;      /* Select 8 bit mode */
   CB1CTL0  = 0xE0;   /* Enable CSIB1 with single R/W, MSB first */

   /* Initialize DSP I/F */
   PMC9    |= 0x1C00; /* Attach CSIB3 unit to I/O pad */
   PFC9    |= 0x1C00;
   PRSCM2   = 3;      /* Select BRG2 out: fxx/6 */
   PRSM2    = 0x10;
   CB3CTL1  = 0x1E;   /* Select fclk=BRG2, SPI mode 0 */
   CB3CTL2  = 0;      /* Select 8 bit mode */
   CB3CTL0  = 0xE0;   /* Enable CSIB3 with single R/W, MSB first */
   PMC9H.5  = 1;      /* Enable INT4 function with rising edge */
   PFC9H.5  = 1;
   INTR9H.5 = 1;

   /* Initialize ADC
   ADA0M0   = 0x20;
   ADA0M1   = 0x01;
   ADA0S    = 0;
   */

   /* Start TM0 in interval time of 1ms */
   TM0CMP0  = SYSCLK / 1000 - 1;
   TM0CTL0  = 0x80;
   TM0EQIC0 = 0x06;   /* Enable TMM0 interrupt with priority level 6 */

   /* Initialize UARTA0 */
   PMC3L   |= 0x03;   /* Attach UARTA0 unit to I/O pad */
   UA0CTL0  = 0x92;   /* Select serial format of N81,115.2kbps */
   UA0CTL1  = 0;
   UA0CTL2  = 20000000 / 2 / 115200;
   UA0CTL0  = 0xF2;

   __EI();
}

void read_dir(void)
{
   volatile BYTE          ok, i;
   volatile unsigned long file_dir_sector, file_dir_sector0, p;
   volatile unsigned char file_dir_sector_count, sector_count, cluster_count;
   volatile unsigned int  file_dir_pos;
   volatile unsigned int  FAT_pos;
   volatile unsigned long FAT_table_next, FAT_table_count;

   volatile char *ptr;
   volatile DWORD ofs;

   err = 0;
   ok  = 0;

   if (!FAT_type) // FAT16
   {
      if (next_file_no>root_entry)
      {
         xputs( " error \r\n\n");
         err = 1;
         return ;
      }
   }

   if (!next_file_no)
      err = 1;
   else
   {
      file_dir_sector0      = 0;

      FAT_table_count       = 0;
      FAT_pos               = 2; /* init : root directory */

      sector_count          = sectors_per_clustor;

      do
      {
         file_dir_sector_count = 1;
         file_dir_pos = ((unsigned int)(next_file_no-1)<<5); // x32
         for (file_dir_sector = 1; file_dir_pos>511; file_dir_sector++)
         {
            file_dir_sector_count ++;
            if (!FAT_type) /* FAT16 */
            {
               file_dir_pos -= 512;
            }
            else /* FAT32 */
            {
               file_dir_pos -= 512;
               if (file_dir_sector_count > sector_count)
               {
                  sector_count += sectors_per_clustor;
                  
                  /* next FAT check */
                  lba = reserved_sectors + FAT_table_count + BPB_sector;
                  MMC_Read(Buff, lba, 1);
/*
                  for (ptr=(char*)Buff, ofs = 0; ofs < 0x200; ptr+=16, ofs+=16)
                    put_dump((BYTE*)ptr, ofs, 16);
                  xputs(" \r\n\n");
*/
                  FAT_pos = (FAT_pos << 2); /* x4 */
                  if ((Buff[FAT_pos]==0xFF)&&(Buff[FAT_pos+1]==0xFF)&&(Buff[FAT_pos+2]==0xFF)&&(Buff[FAT_pos+3]=0x0F))
                  {
                     file_dir_sector --;
                     if (file_no_search)
                     {
                        max_file_no = next_file_no; /* when no_file, max_file_no=1 */
                        file_no_search = 0;
                     }
                     ok = 1;
                  }
                  else
                  {
                     file_dir_sector = LD_DWORD(&Buff[FAT_pos]);
                     
                     FAT_table_next = file_dir_sector -1;
                     FAT_table_count = (FAT_table_next >> 7); /* 1/128 */
                     while (FAT_table_next > 128)
                     {
                        FAT_table_next -= 128;
                     }
                     FAT_pos = (unsigned int)FAT_table_next;
                     FAT_pos --;
                     
                     file_dir_sector -= 2;
                     p = 0;
                     for (i=0; i<sectors_per_clustor; i++)
                     {
                        p += file_dir_sector;
                     }
                     file_dir_sector = p;

                     xprintf(" next directory sector: %lu\r\n", file_dir_sector);

                     file_dir_sector ++;
                  }
               }
            }
         }

         xprintf(" file_dir_pos: %u\r\n", file_dir_pos);
/*
         while (P7L.0) 
	       ;
         Delay(100);
         while (!P7L.0)
           ;
*/
         /* directory read */
         if (file_dir_sector_count != file_dir_sector0)
         {
            file_dir_sector0 = file_dir_sector_count;
            lba = root_directory + (DWORD)file_dir_sector + BPB_sector - 1;
            MMC_Read(Buff, lba, 1);

            xprintf(" Sector:%lu\r\n",lba);
            for (ptr=(char*)Buff, ofs = 0; ofs < 0x200; ptr+=16, ofs+=16)
              put_dump((BYTE*)ptr, ofs, 16);
            xputs(" \r\n\n");

         }
         if (((Buff[file_dir_pos+8]=='W')&&(Buff[file_dir_pos+9]=='A')&&(Buff[file_dir_pos+10]=='V')) ||
             ((Buff[file_dir_pos+8]=='M')&&(Buff[file_dir_pos+9]=='P')&&(Buff[file_dir_pos+10]=='3')))
         {
            if (!file_no_search) ok = 1;
            file_find = 1;

            xputs(" file find \r\n\n");
         }
         else
         {
            /* Upper limit check */
            if ((!Buff[file_dir_pos])&&(!next_file_direct))
            {
               if (file_no_search)
               {
                  max_file_no = next_file_no; /* when no_file, max_file_no=1 */
                  file_no_search = 0;
                  ok = 1;
               }
               else
               {
                  if (!file_find)
                  {
                     err = 1;
                  }
               }
               next_file_no = 0;  /* normal(loop) */
            }

            /* Lower limit check */
            if ((next_file_no==1)&&next_file_direct)
            {
               next_file_no = max_file_no;
            }
         }

         /* for search */
         if (!ok)
         {
            if (next_file_direct)
               next_file_no --;
            else
               next_file_no ++;

            if (!next_file_no)
			{
			   err = 1;
			}
         }
      } while ((!ok)&&(!err));

      if (!err)
      {
         fd_next_clustor  = ((unsigned int)Buff[file_dir_pos + 27]<<8);
         fd_next_clustor += (unsigned int)Buff[file_dir_pos + 26];
         file_size_byte0  = (unsigned long)Buff[file_dir_pos + 31];
         for (i=3; i>0; i--)
         {
            file_size_byte0  = (file_size_byte0<<8);
            file_size_byte0 += (unsigned long)(Buff[file_dir_pos + 27 + i]);
         }
         file_size_sector = (file_size_byte0>>9); /* 1/512 */
      }
   }
}

void VS_WRITE(void)
{
   unsigned int  rptr, cnt;
   unsigned char d;

   vsreg_write(SPI_MODE, 0x0c00);
   do
   {
      if (DREQ == 1)
      {
         rptr = ofs_r;
         cnt  = remain;

         /* vsreg_write(SPI_MODE, 0x0c00); */
	     do
	     {
	        d = Buff[rptr];
            rptr ++;
            do; while (CB3TSF);
            CB3TXL = d;
         } while (--cnt > 0 && DREQ == 1);
         do; while (CB3TSF);
	     /* vsreg_write(SPI_MODE, 0x0800); */
         ofs_r = rptr;
         remain = cnt;
 
         if (!remain)
            buf_rd = 0;
      }
   } while (buf_rd);
   vsreg_write(SPI_MODE, 0x0800);
}

BYTE audio_play(void)
{
   volatile unsigned int  sector_count, i;
   volatile BYTE          sw_in;

   sw_in = 0;

   read_dir();
   sector_count = file_size_sector;

   if (err)
      return  PLAY_STOP;

   fd_next_sector = data_area_start;
   for (i=0; i<sectors_per_clustor; i++)
   {
      fd_next_sector += (DWORD)fd_next_clustor;
      fd_next_sector -= 2;
   }

   lba = fd_next_sector + BPB_sector;

   buf_rd = 0;

   do
   {
      do; while(buf_rd);

      MMC_Read(Buff, lba, 1);
      buf_rd = 1;
      ofs_r   = 0;
      remain  = 512;
      sector_count --;
      lba ++;

      VS_WRITE();

      if (!sector_count) sw_in = PLAY_UP;

      if ((P7L&0x07)!=0x07)
      {
         if (!P7L.0)
         {
            sw_in = PLAY_STOP;
            while (!P7L.0)
               ;
         }
         if (!P7L.1)
         {
            sw_in = PLAY_UP;
            while (!P7L.1)
               ;
         }
         if (!P7L.2)
         {
            sw_in = PLAY_DOWN;
            while (!P7L.2)
               ;
         }
      }

   } while (!sw_in);

   return sw_in;
}

void vsreg_write(UINT reg, WORD val)
{
   do; while(!DREQ);
   XCS = 0;
   PUT_CB3(VS_WRITE_COMMAND);
   PUT_CB3((BYTE)reg);
   PUT_CB3((BYTE)(val >> 8));
   PUT_CB3((BYTE)val);
   XCS = 1;
   do; while(!DREQ);
}

void VsSineTest(void)
{
   vsreg_write(SPI_MODE, 0x0c20);
   PUT_CB3(0x53);
   PUT_CB3(0xef);
   PUT_CB3(0x6e);
   PUT_CB3(0x44);
   PUT_CB3(0x00);
   PUT_CB3(0x00);
   PUT_CB3(0x00);
   PUT_CB3(0x00);
   vsreg_write(SPI_MODE, 0x0820);

   /* wait for KEY push */
   while (P7L.0) 
	    ;

   vsreg_write(SPI_MODE, 0x0c20);
   PUT_CB3(0x45);
   PUT_CB3(0x78);
   PUT_CB3(0x69);
   PUT_CB3(0x74);
   PUT_CB3(0x00);
   PUT_CB3(0x00);
   PUT_CB3(0x00);
   PUT_CB3(0x00);
   vsreg_write(SPI_MODE, 0x0820);
}

void VS_Init(void)
{
   xputs(" VS1053 Init \r\n\n ");

   /* Un-reset VS1053 chip */
   XRESET = 1;
   XCS    = 0;
   vsreg_write(SPI_MODE, 0x0800);
   do; while(!DREQ);
   /* xputs(" Un-reset \r\n\n "); */

   /* Set clock register */
   vsreg_write(SPI_CLOCKF, 0xf800); /* XTALIx5, 2.0x */
   Delay(1);
   do; while(!DREQ);
   /* xputs(" Set clock register \r\n\n "); */

   /* Soft reset */
   vsreg_write(SPI_MODE, 0x0804);
   Delay(1);
   do; while(!DREQ);
   vsreg_write(SPI_CLOCKF, 0xf800);
   Delay(1);
   do; while(!DREQ);
   /* xputs(" Soft reset \r\n\n "); */

   vsreg_write(SPI_WRAMADDR, 0xc013);
   vsreg_write(SPI_VOL, 0x3C3C);

   LoadPatch();

   /* VS1053 sine test function */
   /*
   xputs(" Sine test on  \r\n\n ");
   VsSineTest();
   xputs(" Sine test off \r\n\n ");
   */
}


void main(void)
{
   volatile BYTE  sw_data, j;
   volatile int   tm, i;
   volatile char *ptr;
   volatile DWORD p, ofs;

   /* Disable Debugging I/F */
   PRCMD  = 0;
   OCDM   = 0;

   /* Disable Internal OSC/WDT */
   RCM    = 1;
   WDTM2  = 0;

   /* Set wait state for peripherals */
   VSWC   = 1;

   /* Select clock source: PLLx4 */
   do; while(LOCKR);
   PLLCTL = 3;
   PRCMD  = 0;
   PCC    = 0;

   /* Initialize .sdata sections */
   _rcopy(&_S_romp, -1);

   init();

   /* wait for KEY push */
   while (P7L.0) 
	    ;
   Delay(100);
   while (!P7L.0)
        ;

   xputs(" MP3 player test monitor for V850ES \r\n\n ");

   /* init LED port */
   PMCT.6 = 0;

   /* VS1053 Initialize */
   VS_Init();

   /* SD Initialize */
   MMC_CardInit();

   /* Master Boot Record(MBR) read */
   p = 0;
   MMC_Read(Buff, p, 1);
   /* BPB_sector = (DWORD)Buff[454]; */
   BPB_sector = LD_DWORD(&Buff[454]);

   for (ptr=(char*)Buff, ofs = 0; ofs < 0x200; ptr+=16, ofs+=16)
      put_dump((BYTE*)ptr, ofs, 16);
   xputs(" \r\n\n");
/*
   p = 0;
   while(1)
   {

   xprintf(" Sector:%lu\r\n", p);

   MMC_Read(Buff, p, 1);
   p ++;

   for (ptr=(char*)Buff, ofs = 0; ofs < 0x200; ptr+=16, ofs+=16)
      put_dump((BYTE*)ptr, ofs, 16);
   xputs(" \r\n\n");

   while (P7L.0) 
	    ;
   Delay(100);
   while (!P7L.0)
        ;
   }
*/
   /* BIOS Parameter Block(BPB) read */
   p = BPB_sector;
   MMC_Read(Buff, p, 1);

   xprintf(" BIOS Parameter Block(BPB) : Sector:%lu\r\n", p);
   
   for (ptr=(char*)Buff, ofs = 0; ofs < 0x200; ptr+=16, ofs+=16)
      put_dump((BYTE*)ptr, ofs, 16);
   xputs(" \r\n\n");

   bytes_per_sector    = (((unsigned int)(Buff[12]))<<8)|((unsigned int)(Buff[11]));
   sectors_per_clustor = Buff[13];
   reserved_sectors    = (((unsigned int)(Buff[15]))<<8)|((unsigned int)(Buff[14]));

   if ((Buff[22]==0)&&(Buff[23]==0)) /* FAT32 */
   {
      FAT_type = 1;
      xputs(" FAT32 \r\n\n");
      /* sectors_per_FAT     = (DWORD)(((unsigned int)(Buff[37]))<<8)|((unsigned int)(Buff[36])); */
      sectors_per_FAT     = LD_DWORD(&Buff[36]);
      root_directory      = (DWORD)reserved_sectors;
      for (i=0; i<Buff[16]; i++)
          root_directory += sectors_per_FAT;

      p = /* (LD_DWORD(Buff[44])-2)*sector_per_clustor + */ (DWORD)root_directory + BPB_sector;

      root_entry          = (((unsigned int)(Buff[18]))<<8)|((unsigned int)(Buff[17]));
      root_entry_sectors  = (BYTE)(root_entry>>4); /* 512/16=32 */
      data_area_start     = root_directory;
   }
   else
   {
      FAT_type = 0;
      xputs(" FAT16 \r\n\n");
      sectors_per_FAT     = (DWORD)(((unsigned int)(Buff[23]))<<8)|((unsigned int)(Buff[22]));
      root_directory      = (DWORD)reserved_sectors;
      for (i=0; i<Buff[16]; i++)
          root_directory += sectors_per_FAT;

      p = root_directory + BPB_sector;

      root_entry          = (((unsigned int)(Buff[18]))<<8)|((unsigned int)(Buff[17]));
      root_entry_sectors  = (BYTE)(root_entry>>4); /* 512/16=32 */
      data_area_start     = (DWORD)root_entry_sectors;
      data_area_start    += root_directory;
   }

   xprintf(" BPB_sector         : 0x%04X \r\n", BPB_sector);
   xprintf(" bytes_per_sector   : 0x%04X \r\n", bytes_per_sector);
   xprintf(" sectors_per_clustor: 0x%02X \r\n", sectors_per_clustor);
   xprintf(" reserved_sectors   : 0x%04X \r\n", reserved_sectors);
   xprintf(" root_entry         : 0x%04X \r\n", root_entry);
   xprintf(" sectors_per_FAT    : 0x%04X \r\n", sectors_per_FAT);
   xprintf(" root_directory     : 0x%04X \r\n", root_directory);
   xprintf(" root_entry_sectors : 0x%02X \r\n", root_entry_sectors);
   xprintf(" data_area_start    : 0x%04X \r\n", data_area_start);

   /* root directiry */
   MMC_Read(Buff, p, 1);

   xprintf(" root directory sector:%lu\r\n", p);

   for (ptr=(char*)Buff, ofs = 0; ofs < 0x200; ptr+=16, ofs+=16)
      put_dump((BYTE*)ptr, ofs, 16);
   xputs(" \r\n\n");

   file_no_search   = 1;
   next_file_no     = 1; /* for max_file_no search */

   read_dir();      /* set max_file_no; next_file_no = 0 */

   xprintf(" max file no : %u \r\n", max_file_no);

   next_file_direct = 0;
   next_file_no     = 1;

   xputs(" Player start \r\n\n ");

   sw_data = 0;
   while (!sw_data)
   {
      sw_data = audio_play();

      if (sw_data)
      {
         vsreg_write(SPI_MODE, SM_OUTOFWAV);
         do; while(!DREQ);

         vsreg_write(SPI_MODE, 0x0c00);
         for (i = 0; i<1048; i++)
         {
             while (!DREQ)
                ;
             do; while (CB3TSF);
             CB3TXL = 0;
         }
         do; while (CB3TSF);
         vsreg_write(SPI_MODE, 0x0800);

         /* Soft reset */
         vsreg_write(SPI_MODE, 0x0804);
         Delay(10);
         do; while(!DREQ);
         vsreg_write(SPI_CLOCKF, 0xf800);
         Delay(10);
         do; while(!DREQ);

         LoadPatch();

         if (sw_data==PLAY_UP)
         {
            next_file_no ++;
            next_file_direct = 0;
            sw_data = 0;
         }
         if (sw_data==PLAY_DOWN)
         {
            next_file_no --;
            next_file_direct = 1;
            sw_data = 0;
         }
      }
   }
   /*
   for (ptr=(char*)Buff, ofs = 0; ofs < 0x200; ptr+=16, ofs+=16)
      put_dump((BYTE*)ptr, ofs, 16);
   xputs(" \r\n\n");
   */

   while(1)
   {
      for( tm=0 ; tm<600000 ; tm++ ) __nop();
      {
         PCT.6 ^= 1;
      }
   }
}

/* 1000Hz timer interrupt generated by TMM0 */

#pragma interrupt INTTM0EQ0 ISR_tmm0
__interrupt
void ISR_tmm0 (void)
{
   unsigned int  n;
/*
   unsigned int  rptr, cnt;
   unsigned char d;
*/
   n = Timer1;   /* 1000Hz decrement timer */
   if (n)
      Timer1 = --n;
/*
   if (buf_rd)
   {
      if (DREQ == 1)
      {
         rptr = ofs_r;
         cnt  = remain;

         vsreg_write(SPI_MODE, 0x0c00);
	     do
	     {
	        d = Buff[rptr];
            rptr ++;
            do; while (CB3TSF);
            CB3TXL = d;
         } while (--cnt > 0 && DREQ == 1);
         do; while (CB3TSF);
	     vsreg_write(SPI_MODE, 0x0800);
         ofs_r = rptr;
         remain = cnt;
 
         if (!remain)
            buf_rd = 0;
      }
   }
*/
   /*
   if (!n)
   {
      PCT.6 ^= 1;
      Timer1 = 1000;
   }
   */
}

